# CampPCT 0.3
# Author: Scottix
# Questions or comments
# Email: Scottix@Gmail.com

import es
import playerlib
import popuplib

###################Config Section#########################

# Amount of time in seconds before CampPCT starts tracking
pre_camp = 30

# The radius to consider as camping
camp_radius = 100

# How often to check the location of player in seconds
# The bigger the number the less accurate (decimal OK)
camp_delay = 1

# Turn off tracking when performing bombing events
# 1 = on
# 0 = off
camp_bomb = 1

# When to display CampPCT to user
# 0 = never
# 1 = spawn
# 2 = death
camp_tell = 1

# Say command to display their percentage
camp_say = 'camppct'

# Say command to display top campers
camp_saytop = 'campers'

# Timout of top10 view
# 0 = Have to push a number to exit
camp_toptimeout = 5

# Slap on spawn
# 1 = on
# 0 = off
camp_slap = 0

# Following options camp_slap = 1

# Percentage allowed to camp on the server
camp_pct = 60

# Amount of time in seconds before you start slapping
camp_count = 30

# Default: slap 5 heath every 5 percent over
# Example: 12% over would be 10 health
slap_pct = 5
slap_health = 5

###########################################################
#################Do Not Edit Below#########################
###########################################################

info = es.AddonInfo()
info.name = 'CampPCT'
info.version = '0.3'
info.basename = 'camppct'
info.author = 'Scottix@GMail.com'

# Init Variables
camp = {} # Count the number of time camping 
count = {} # Count the number of times checked
pct = {} # Current Percentage of user
dead = {} # Check if the player is dead
afk = {} # Check if the player is AFK
first_pos = {} # This is used to check for afk
pos = {} # Players last position
total_count = 0 # This is used for initial time
round_started = 0 # So we can tell if it is DM type spawn

def load():
	es.set(info.basename,info.version)
	es.makepublic(info.basename)
	es.msg('#multi','#green[CampPCT]#default Loaded.')
	
def unload():
	es.msg('#multi','#green[CampPCT]#default Unloaded.')

def init():
	global camp,count,pct,dead,pos,total_count

	# Init Variables
	camp = {}
	count = {}
	pct = {}
	dead = {}
	afk = {}
	firs_pos = {}
	pos = {}
	total_count = 0
	round_started = 0

def player_say(e):
	global pct,camp_say,camp_saytop,camp_toptimeout,pre_camp,total_count
	userid = e['userid']
	text = e['text']

	if (total_count > pre_camp):
		if (text == camp_saytop):
			campers = popuplib.create('campers')
			campers.addline('===Top Campers===')
			counter = 0

			# Sort and show top campers
			items = sorted(pct.items(), key=lambda(k,v):(v,k), reverse=True)
			for k, v in items:
				if (counter < 10):
					campers.addline(str(es.getplayername(k))+' - '+str(v)+'%')
				counter += 1

			# Set display timout
			if (camp_toptimeout != 0):
				campers.timeout('view',camp_toptimeout)
			else:
				campers.addline('0 - Exit')

			# Send display to player
			campers.send(userid)
	
		elif (text == camp_say):
			es.tell(userid,'#multi','#green[CampPCT]#default '+str(int(pct[userid]))+'% Camping rate')
	else:	
		es.tell(userid,'#multi','#green[CampPCT]#default Tracking begins in '+str(pre_camp-total_count)+' seconds')

def player_activate(e):
	global camp,count,pct,dead,pos
	userid = e['userid']

	# Add player to array
	camp[userid] = 0
	count[userid] = 0
	pct[userid] = 0
	dead[userid] = 1
	afk[userid] = 1
	pos[userid] = 0
	first_pos[userid] = 0

def player_disconnect(e):
	global camp,count,pct,dead,pos
	userid = e['userid']

	# Remove player from array
	del camp[userid]
	del count[userid]
	del pct[userid]
	del dead[userid]
	del afk[userid]
	del pos[userid]
	del first_pos[userid]

def verify_vector(userid):
	global camp,count,pct,dead,afk,pos,first_pos
	
	# Only track if they are not dead
	if(dead[userid] == 0):
		loc = es.getplayerprop(userid,'CBaseEntity.m_vecOrigin')

		# Check if they are AFK
		if (afk[userid] == 1):
			# If they have moved they are not afk
			if(camping(loc,first_pos[userid]) == 0):
				afk[userid] = 0
		else:
			if (camping(loc,pos[userid]) == 1):
				camp[userid] += 1
			count[userid] += 1
			pct[userid] = int((float(camp[userid])/float(count[userid]))*100)
			pos[userid] = loc

def camping(loc1,loc2):
			global camp_radius

			(x1, y1, z1) = es.splitvectorstring(loc1)
			(x2, y2, z2) = es.splitvectorstring(loc2)

			x = abs(x1-x2)
			y = abs(y1-y2)
			z = abs(z1-z2)

			# Camping if this is true
			if((x < camp_radius) and (y < camp_radius) and (z < camp_radius)):
				return 1
			else:
				return 0

def check_player():
	global pct,pre_camp,total_count,camp_delay,round_started

	# Don't check until pre time has finished
	if(total_count > pre_camp):
		for k, v in pct.iteritems():
			verify_vector(k)
	elif (round_started == 1):
		total_count += 1;

	es.delayed(camp_delay,'es_doblock camppct/check_player')

def es_map_start(e):
	init()
	check_player()

def player_spawn(e):
	global pct,dead,afk,count,pos,first_pos,camp_pct,camp_count,camp_tell,camp_slap,slap_pct,slap_health,total_count,pre_camp,round_started
	userid = e['userid']
	afk[userid] = 1

	# This is to check for DM spawn
	if (round_started == 1):
		dead[userid] = 0
	
	# Get Current Location
	loc = es.getplayerprop(userid,'CBaseEntity.m_vecOrigin')
	pos[userid] = loc
	first_pos[userid] = loc

	if (pct[userid] >= camp_pct and count[userid] >= camp_count and camp_slap == 1):
		player=playerlib.getPlayer(userid)
		curHealth = player.get('health')
		slapped = curHealth - (int(((pct[userid] - camp_pct) / slap_pct)) * slap_health)
		player.set('health',slapped)
		es.tell(userid,'#multi','#green[CampPCT]#default '+str(pct[userid])+'% Camping rate slapped '+str(curHealth-slapped)+' health.')
	elif (total_count <= pre_camp and camp_tell == 1):
		es.tell(userid,'#multi','#green[CampPCT]#default Tracking begins in '+str(pre_camp-total_count)+' seconds')
	elif (camp_tell == 1):
		es.tell(userid,'#multi','#green[CampPCT]#default '+str(int(pct[userid]))+'% Camping rate')

def player_death(e):
	global dead,pct,total_count,pre_camp
	userid = e['userid']
	dead[userid] = 1

	if (total_count <= pre_camp and camp_tell == 2):
		es.tell(userid,'#multi','#green[CampPCT]#default Tracking begins in '+str(pre_camp-total_count)+' seconds')
	elif (camp_tell == 2):
		es.tell(userid,'#multi','#green[CampPCT]#default '+str(pct[userid])+'% Camping rate')

def bomb_beginplant(e):
	global camp_bomb,dead
	userid = e['userid']

	if(camp_bomb == 1):
		dead[userid] = 1

def bomb_planted(e):
	global camp_bomb,dead
	userid = e['userid']

	if(camp_bomb == 1):
		dead[userid] = 0

def bomb_begindefuse(e):
	global camp_bomb,dead
	userid = e['userid']

	if(camp_bomb == 1):
		dead[userid] = 1

def bomb_defused(e):
	global camp_bomb,dead
	userid = e['userid']

	if(camp_bomb == 1):
		dead[userid] = 0

def round_start(e):
	global dead,round_started
	for k, v in dead.iteritems():
		dead[k] = 0
	round_started = 1

def round_end(e):
	global dead,round_started
	for k, v in dead.iteritems():
		dead[k] = 1
	round_started = 0
